/*
	IV окружной этап Всероссийской олимпиады школьников по информатике
	24 - 28 марта 2006 г.
	г. Петрозаводск

	Задача E. Кенгуренок Лео
	Авторы: А. Николаевский
	Решение: М. Бурдин
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SIZE 65536

int a, b, n, start, end, l[SIZE], u1[SIZE], y1[SIZE], *y, *u;

void add(int nx, int t) {
        if (!u[nx]) {
                u[nx] = t;
                if (nx < a || nx >= b) {
                        printf("%i", t - 1);
                        exit(0);
                }
                l[end++] = nx;
        }
}

int main() {
        int ch, h, r, m, z, i, j, minh, dir, x, nx;
        
        freopen("leo.in", "r", stdin);
        freopen("leo.out", "w", stdout);
        scanf("%i%i%i%i%i%i", &a, &b, &h, &n, &r, &m);
	
        for (i = 0; i < sizeof(y1) / sizeof(y1[0]); i++) y1[i] = h;
        y = y1 - a + 2 * n;
        for (i = a; i < b; i++) y[i] = 0;
        for (i = 0; i < m; i++) {
                scanf("%i%i%i", &start, &end, &z);
                for (j = start; j < end; j++) y[j] = z;
        }
        
        memset(u1, 0, sizeof(u1));
        u = u1 - a + 2 * n;
        start = 0;
        end = 0;
        add(0, 1);
        while (start < end) {
                x = l[start++];
                for (dir = -1; dir <= 1; dir += 2) {
                        minh = 1;
                        for (i = 1; i < n; i++) {
                                nx = x + dir * i; 
				if (y[nx] >= y[x] + minh) {
                                        minh = y[nx] - y[x] + 1;
                                }
                                if (minh + i > n) break;
                                
				ch = y[x] + (n - i) - y[nx];
                                if (!u[nx]) {
                                        if (ch <= r) {
                                                add(nx, u[x] + 1);
                                        }
                                }
                        }
                }
	}
        
        printf("0");
        return 0;
}
